using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Drawing.Text;


namespace WatermarkClock
{
    public partial class Form1 : Form
    {
        Point thelocation = new Point( System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width + 1124 - 1680 /*1124*/, 100);
        Bitmap canvas;
        Graphics g;
        Brush b;
        Font f;
        Font fs;
        Font fm;
        
        static DateTime lastDraw;
        readonly string[] STR_WEEK = 
            { "SUNDAY", "MONDAY", "TUESDAY", "WEDNESDAY", "THURSDAY", "FRIDAY", "SATURDAY" };

        readonly string[] STR_MONTH =
            {"","JANUARY","FEBRUARY","MARCH","APRIL","MAY","JUNE","JULY",
             "AUGUST","SEPTEMBER","OCTOBER","NOVEMBER","DECEMBER"};

        
        public Form1()
        {
            InitializeComponent();
        }

        private void DrawIt()
        {
            DateTime now = DateTime.Now;

            timer1.Stop();
            timer1.InitializeLifetimeService();
            timer1.Interval = 1000 * 10
                    - ((now.Second * 1000 + now.Millisecond) % (1000 * 10));
            timer1.Enabled = true; 
            timer1.Start();


            this.TopMost = false;
            this.TopMost = true;
            this.Location = thelocation;

            if ((lastDraw.Hour * 60 + lastDraw.Minute)
            == (now.Hour * 60 + now.Minute))
            {
                return;
            }

            lastDraw = now;  
            //using System.Drawing;

            //描画先とするImageオブジェクトを作成する
            //ImageオブジェクトのGraphicsオブジェクトを作成する
            
            g.TextRenderingHint = TextRenderingHint.SingleBitPerPixel;

            g.Clear(Color.Transparent);
            g.SmoothingMode = SmoothingMode.None;
            //半透明のブラシを作成する

            //文字列を描画する

            String stime = now.ToString("h:mm");
            String smonth = STR_MONTH[now.Month];
            String sday = now.Day.ToString();
            String sweek = STR_WEEK[(int)now.DayOfWeek];
            String sampm = ((now.Hour>=12)?"PM":"AM").ToString();

            g.DrawString(stime, f, b, (float)360.0 - g.MeasureString(stime, f).Width, 0);
            g.DrawString(smonth, fs, b,
                (float)350.0 - g.MeasureString(smonth, fs).Width, 120);
            g.DrawString(sweek, fs, b,
                (float)350.0 - g.MeasureString(sweek, fs).Width, 170);
            g.DrawString(sday, f, b, 
                (float)345.0 + 135 / 2 - g.MeasureString(sday, f).Width / 2, 106);

            g.DrawString(sampm, fm, b, 
                (float)345.0 + 135 / 2 - g.MeasureString(sampm, fm).Width / 2, 38);
            
            //PictureBox1に表示する
            pictureBox1.Image = canvas;
        }

        private void Form1_Load(object sender, EventArgs e)
        {//using System.Drawing;
            timer1.Tick += new EventHandler(timer1_Tick);
            this.FormBorderStyle = FormBorderStyle.None;
            this.ControlBox = false;
            this.Text = "";
            this.TransparencyKey = Color.White;
            this.Opacity = 0.25;
            this.Enabled = false;
            this.Location = thelocation;

            canvas = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            g = Graphics.FromImage(canvas);
            b = new SolidBrush(Color.FromArgb(255, 136, 136, 255));
            f = new Font("Century Gothic", 86);
            fs = new Font("Century Gothic", 37);
            fm = new Font("Century Gothic", 56);

            DrawIt();
        }
        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams cp = base.CreateParams;
                cp.ExStyle |= 0x20; // 無反応Window
                return cp;
            }
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            DrawIt();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

    }
}